#include <tcl.h>

typedef struct MajorMinor_CommandToken *MajorMinor_CommandToken;

typedef struct {
  char *subcommandName;
  Tcl_ObjCmdProc *proc;
  ClientData clientData;
  Tcl_CmdDeleteProc *deleteProc;
} MajorMinor_Subcommand;

EXTERN MajorMinor_CommandToken
Majorminor_GetCommandToken     _ANSI_ARGS_((Tcl_Interp *interp,
					    char *name));
EXTERN MajorMinor_CommandToken
Majorminor_CreateCommand       _ANSI_ARGS_((Tcl_Interp *interp,
					    char *name,
					    char *msg,
					    int flags));
EXTERN void
Majorminor_AddSubcommandSet    _ANSI_ARGS_((MajorMinor_CommandToken command,
					    MajorMinor_Subcommand *subcmdSet));
EXTERN int
Majorminor_RemoveSubcommandSet _ANSI_ARGS_((Tcl_Interp *interp,
					    MajorMinor_CommandToken command,
					    MajorMinor_Subcommand *subcmdSet));

EXTERN int Majorminor_Init _ANSI_ARGS_((Tcl_Interp *interp));
